diff -r -u -H -N gcc-2.6.3/config/i386/i386.h gcc-i2.6.3/config/i386/i386.h
--- gcc-2.6.3/config/i386/i386.h	Wed Oct 19 16:52:09 1994
+++ gcc-i2.6.3/config/i386/i386.h	Wed Feb 15 23:07:40 1995
@@ -1239,13 +1201,41 @@
    When -fpic is used, special handling is needed for symbolic references.
    See comments by legitimize_pic_address in i386.c for details.  */
 
-#define LEGITIMIZE_ADDRESS(X, OLDX, MODE, WIN)				\
-{									\
-  rtx orig_x = (X);							\
-  (X) = legitimize_address (X, OLDX, MODE);				\
-  if (memory_address_p (MODE, X))					\
-    goto WIN;								\
-}
+#define LEGITIMIZE_ADDRESS(X,OLDX,MODE,WIN)   \
+{ extern rtx legitimize_pic_address ();					\
+  int ch = (X) != (OLDX);						\
+  if (flag_pic && SYMBOLIC_CONST (X))					\
+    {									\
+      (X) = legitimize_pic_address (X, 0);				\
+      if (memory_address_p (MODE, X))					\
+	goto WIN;							\
+    }									\
+  if (GET_CODE (X) == PLUS)						\
+    { if (GET_CODE (XEXP (X, 0)) == MULT)				\
+	ch = 1, XEXP (X, 0) = force_operand (XEXP (X, 0), 0);		\
+      if (GET_CODE (XEXP (X, 1)) == MULT)				\
+	ch = 1, XEXP (X, 1) = force_operand (XEXP (X, 1), 0);		\
+      if (ch && GET_CODE (XEXP (X, 1)) == REG				\
+	  && GET_CODE (XEXP (X, 0)) == REG)				\
+	goto WIN;							\
+      if (flag_pic && SYMBOLIC_CONST (XEXP (X, 1)))			\
+        ch = 1, (X) = legitimize_pic_address (X, 0);			\
+      if (ch) { GO_IF_LEGITIMATE_ADDRESS (MODE, X, WIN); }		\
+      if (GET_CODE (XEXP (X, 0)) == REG)                                \
+	{ register rtx temp = gen_reg_rtx (Pmode);			\
+	  register rtx val = force_operand (XEXP (X, 1), temp);		\
+	  if (val != temp) emit_move_insn (temp, val);			\
+	  XEXP (X, 1) = temp;						\
+	  goto WIN; }							\
+      else if (GET_CODE (XEXP (X, 1)) == REG)				\
+	{ register rtx temp = gen_reg_rtx (Pmode);			\
+	  register rtx val = force_operand (XEXP (X, 0), temp);		\
+	  if (val != temp) emit_move_insn (temp, val);			\
+	  XEXP (X, 0) = temp;						\
+	  goto WIN; }}}
+
+/* intel1 */
+#define REWRITE_ADDRESS(x) rewrite_address(x)
 
 /* Nonzero if the constant value X is a legitimate general operand
    when generating PIC code.  It is given that flag_pic is on and 
@@ -1348,6 +1338,10 @@
 /* Nonzero if access to memory by bytes is slow and undesirable.  */
 #define SLOW_BYTE_ACCESS 0
 
+/* intel1 */
+/* Nonzero if access to memory by shorts is slow and undesirable.  */
+#define SLOW_SHORT_ACCESS 1
+
 /* Define if shifts truncate the shift count
    which implies one can omit a sign-extension or zero-extension
    of a shift count.  */
@@ -1469,6 +1463,7 @@
    stored from the compare operation.  Note that we can't use "rtx" here
    since it hasn't been defined!  */
 
+extern struct rtx_def *i386_compare_op0, *i386_compare_op1;
 extern struct rtx_def *(*i386_compare_gen)(), *(*i386_compare_gen_eq)();
 
 /* Tell final.c how to eliminate redundant test instructions.  */
@@ -1476,6 +1471,10 @@
 /* Here we define machine-dependent flags and fields in cc_status
    (see `conditions.h').  */
 
+/* intel1 Set if the cc value is was actually from the 80387 and
+   we are testing eax directly (i.e. no sahf) */
+#define CC_TEST_AX 020000
+
 /* Set if the cc value is actually in the 80387, so a floating point
    conditional branch must be output.  */
 #define CC_IN_80387 04000
@@ -1773,12 +1772,12 @@
 	 { fputs ("argp", FILE); break; }		\
        if (STACK_TOP_P (X))				\
 	 { fputs ("st(0)", FILE); break; }		\
-       if (FP_REG_P (X))				\
-	 { fputs (hi_name[REGNO(X)], FILE); break; }	\
        switch (GET_MODE_SIZE (GET_MODE (X)))		\
 	 {						\
-	 default:					\
-	   fputs ("e", FILE);				\
+	 case 12:					\
+	 case 8:					\
+	 case 4:					\
+	   if (! FP_REG_P (X)) fputs ("e", FILE);	\
 	 case 2:					\
 	   fputs (hi_name[REGNO (X)], FILE);		\
 	   break;					\
@@ -1813,60 +1812,6 @@
 
 #define RET return ""
 #define AT_SP(mode) (gen_rtx (MEM, (mode), stack_pointer_rtx))
-
-/* Functions in i386.c */
-extern void override_options ();
-extern void order_regs_for_local_alloc ();
-extern void output_op_from_reg ();
-extern void output_to_reg ();
-extern char *singlemove_string ();
-extern char *output_move_double ();
-extern char *output_move_memory ();
-extern char *output_move_pushmem ();
-extern int standard_80387_constant_p ();
-extern char *output_move_const_single ();
-extern int symbolic_operand ();
-extern int call_insn_operand ();
-extern int expander_call_insn_operand ();
-extern int symbolic_reference_mentioned_p ();
-extern void emit_pic_move ();
-extern void function_prologue ();
-extern int simple_386_epilogue ();
-extern void function_epilogue ();
-extern int legitimate_address_p ();
-extern struct rtx_def *legitimize_pic_address ();
-extern struct rtx_def *legitimize_address ();
-extern void print_operand ();
-extern void print_operand_address ();
-extern void notice_update_cc ();
-extern void split_di ();
-extern int binary_387_op ();
-extern int shift_op ();
-extern int VOIDmode_compare_op ();
-extern char *output_387_binary_op ();
-extern char *output_fix_trunc ();
-extern char *output_float_compare ();
-extern char *output_fp_cc0_set ();
-extern void save_386_machine_status ();
-extern void restore_386_machine_status ();
-extern void clear_386_stack_locals ();
-extern struct rtx_def *assign_386_stack_local ();
-
-/* Variables in i386.c */
-extern char *i386_reg_alloc_order;		/* register allocation order */
-extern char *hi_reg_name[];			/* names for 16 bit regs */
-extern char *qi_reg_name[];			/* names for 8 bit regs (low) */
-extern char *qi_high_reg_name[];		/* names for 8 bit regs (high) */
-extern enum reg_class regclass_map[];		/* smalled class containing REGNO */
-extern struct rtx_def *i386_compare_op0;	/* operand 0 for comparisons */
-extern struct rtx_def *i386_compare_op1;	/* operand 1 for comparisons */
-
-/* External variables used */
-extern int optimize;			/* optimization level */
-extern int obey_regdecls;		/* TRUE if stupid register allocation */
-
-/* External functions used */
-extern struct rtx_def *force_operand ();
 
 /*
 Local variables:
diff -r -u -H -N gcc-2.6.3/config/i386/osfrose.h gcc-i2.6.3/config/i386/osfrose.h
--- gcc-2.6.3/config/i386/osfrose.h	Wed Oct 26 17:14:11 1994
+++ gcc-i2.6.3/config/i386/osfrose.h	Wed Feb 15 22:46:52 1995
@@ -468,6 +468,10 @@
    defined, is executed once just after all the command options have
    been parsed.  */
 
+#ifdef OVERRIDE_OPTIONS
+#undef OVERRIDE_OPTIONS
+#endif
+
 #undef  SUBTARGET_OVERRIDE_OPTIONS
 #define SUBTARGET_OVERRIDE_OPTIONS					\
 {									\
diff -r -u -H -N gcc-2.6.3/cp/parse.c gcc-i2.6.3/cp/parse.c
--- gcc-2.6.3/cp/parse.c	Fri Oct 14 14:51:23 1994
+++ gcc-i2.6.3/cp/parse.c	Tue Dec 20 16:53:24 1994
@@ -190,7 +190,7 @@
 
 
 
-#define	YYFINAL		1356
+#define	YYFINAL		1350
 #define	YYFLAG		-32768
 #define	YYNTBASE	106
 
@@ -257,59 +257,59 @@
    630,   635,   640,   642,   646,   650,   654,   658,   662,   666,
    670,   674,   678,   682,   686,   690,   694,   698,   702,   706,
    710,   714,   718,   724,   728,   732,   734,   737,   741,   743,
-   745,   747,   749,   751,   753,   755,   758,   761,   765,   767,
-   769,   771,   775,   777,   779,   781,   783,   787,   791,   792,
-   797,   798,   805,   808,   813,   816,   819,   821,   826,   828,
-   836,   844,   852,   860,   865,   870,   873,   876,   878,   883,
-   886,   889,   892,   898,   902,   908,   912,   917,   924,   926,
-   929,   931,   934,   936,   938,   940,   943,   944,   947,   950,
-   954,   958,   962,   966,   970,   973,   976,   978,   980,   982,
-   985,   988,   991,   994,   996,   998,  1000,  1002,  1005,  1008,
-  1012,  1016,  1021,  1023,  1026,  1029,  1031,  1033,  1036,  1039,
-  1041,  1044,  1047,  1051,  1053,  1056,  1058,  1060,  1062,  1067,
-  1072,  1077,  1082,  1084,  1086,  1088,  1090,  1094,  1096,  1100,
-  1102,  1106,  1107,  1112,  1113,  1121,  1126,  1127,  1135,  1140,
-  1141,  1149,  1154,  1155,  1163,  1168,  1169,  1171,  1173,  1176,
-  1183,  1185,  1189,  1190,  1192,  1197,  1204,  1209,  1211,  1213,
-  1215,  1217,  1219,  1223,  1225,  1228,  1232,  1237,  1239,  1241,
-  1245,  1250,  1257,  1261,  1267,  1268,  1276,  1281,  1282,  1289,
-  1293,  1296,  1299,  1304,  1306,  1307,  1309,  1310,  1312,  1314,
-  1317,  1320,  1323,  1326,  1330,  1333,  1336,  1339,  1343,  1347,
-  1349,  1352,  1353,  1354,  1358,  1362,  1365,  1367,  1369,  1370,
-  1372,  1375,  1377,  1381,  1383,  1386,  1388,  1393,  1398,  1400,
-  1402,  1405,  1408,  1410,  1411,  1413,  1418,  1422,  1424,  1427,
-  1430,  1433,  1436,  1439,  1442,  1445,  1448,  1453,  1456,  1458,
-  1464,  1468,  1469,  1471,  1475,  1476,  1478,  1482,  1484,  1486,
-  1488,  1490,  1495,  1502,  1507,  1512,  1519,  1524,  1528,  1533,
-  1540,  1545,  1550,  1557,  1562,  1566,  1568,  1572,  1574,  1578,
-  1581,  1583,  1590,  1591,  1594,  1596,  1599,  1600,  1603,  1607,
-  1611,  1614,  1617,  1621,  1623,  1625,  1627,  1630,  1636,  1642,
-  1646,  1652,  1657,  1661,  1665,  1668,  1670,  1674,  1678,  1681,
-  1684,  1688,  1690,  1694,  1698,  1701,  1704,  1708,  1710,  1716,
-  1722,  1726,  1732,  1736,  1741,  1745,  1748,  1751,  1753,  1756,
-  1761,  1766,  1769,  1771,  1773,  1775,  1778,  1781,  1784,  1786,
-  1789,  1791,  1794,  1797,  1801,  1803,  1807,  1810,  1814,  1817,
-  1820,  1824,  1826,  1830,  1835,  1839,  1842,  1845,  1847,  1851,
-  1854,  1857,  1859,  1862,  1866,  1868,  1872,  1874,  1880,  1884,
-  1889,  1893,  1898,  1901,  1904,  1908,  1911,  1913,  1915,  1918,
-  1921,  1924,  1925,  1926,  1928,  1930,  1933,  1937,  1939,  1942,
-  1946,  1952,  1959,  1965,  1966,  1967,  1974,  1976,  1979,  1981,
-  1983,  1985,  1988,  1989,  1994,  1996,  1997,  1998,  2005,  2006,
-  2007,  2015,  2016,  2017,  2018,  2029,  2030,  2031,  2032,  2043,
-  2044,  2052,  2053,  2059,  2060,  2068,  2069,  2074,  2077,  2080,
-  2083,  2087,  2094,  2103,  2114,  2127,  2132,  2136,  2139,  2142,
-  2144,  2146,  2147,  2148,  2156,  2158,  2161,  2164,  2165,  2166,
-  2172,  2174,  2176,  2180,  2184,  2187,  2190,  2193,  2197,  2202,
-  2207,  2211,  2216,  2223,  2230,  2231,  2233,  2234,  2236,  2238,
-  2239,  2241,  2243,  2247,  2252,  2254,  2258,  2259,  2261,  2263,
-  2265,  2268,  2271,  2274,  2276,  2278,  2281,  2284,  2287,  2290,
-  2292,  2296,  2299,  2302,  2307,  2310,  2313,  2316,  2319,  2322,
-  2325,  2327,  2330,  2332,  2336,  2338,  2340,  2341,  2342,  2344,
-  2345,  2350,  2352,  2354,  2358,  2359,  2363,  2367,  2371,  2373,
-  2376,  2379,  2382,  2385,  2388,  2391,  2394,  2397,  2400,  2403,
-  2406,  2409,  2412,  2415,  2418,  2421,  2424,  2427,  2430,  2433,
-  2436,  2439,  2442,  2446,  2449,  2452,  2455,  2458,  2462,  2465,
-  2468,  2473,  2478,  2482
+   745,   747,   749,   751,   753,   755,   758,   761,   763,   765,
+   767,   769,   771,   773,   775,   779,   783,   784,   789,   790,
+   797,   800,   805,   808,   811,   813,   818,   820,   828,   836,
+   844,   852,   857,   862,   865,   868,   870,   875,   878,   881,
+   884,   890,   894,   900,   904,   909,   916,   918,   921,   923,
+   926,   928,   930,   932,   935,   936,   939,   942,   946,   950,
+   954,   958,   962,   965,   968,   970,   972,   974,   977,   980,
+   983,   986,   988,   990,   992,   994,   997,  1000,  1004,  1008,
+  1013,  1015,  1018,  1021,  1023,  1025,  1028,  1031,  1033,  1036,
+  1039,  1043,  1045,  1048,  1050,  1052,  1054,  1059,  1064,  1069,
+  1074,  1076,  1078,  1080,  1082,  1086,  1088,  1092,  1094,  1098,
+  1099,  1104,  1105,  1113,  1118,  1119,  1127,  1132,  1133,  1141,
+  1146,  1147,  1155,  1160,  1161,  1163,  1165,  1168,  1175,  1177,
+  1181,  1182,  1184,  1189,  1196,  1201,  1203,  1205,  1207,  1209,
+  1211,  1215,  1217,  1220,  1224,  1229,  1231,  1233,  1237,  1242,
+  1249,  1253,  1259,  1260,  1268,  1273,  1274,  1281,  1285,  1288,
+  1291,  1296,  1298,  1299,  1301,  1302,  1304,  1306,  1309,  1312,
+  1315,  1318,  1322,  1325,  1328,  1331,  1335,  1339,  1341,  1344,
+  1345,  1346,  1350,  1354,  1357,  1359,  1361,  1362,  1364,  1367,
+  1369,  1373,  1375,  1378,  1380,  1385,  1390,  1392,  1394,  1397,
+  1400,  1402,  1403,  1405,  1410,  1414,  1416,  1419,  1422,  1425,
+  1428,  1431,  1434,  1437,  1440,  1445,  1448,  1450,  1456,  1460,
+  1461,  1463,  1467,  1468,  1470,  1474,  1476,  1478,  1480,  1482,
+  1487,  1494,  1499,  1504,  1511,  1516,  1520,  1525,  1532,  1537,
+  1542,  1549,  1554,  1558,  1560,  1564,  1566,  1570,  1573,  1575,
+  1582,  1583,  1586,  1588,  1591,  1592,  1595,  1599,  1603,  1606,
+  1609,  1613,  1615,  1617,  1619,  1622,  1628,  1634,  1638,  1644,
+  1649,  1653,  1657,  1660,  1662,  1666,  1670,  1673,  1676,  1680,
+  1682,  1686,  1690,  1693,  1696,  1700,  1702,  1708,  1714,  1718,
+  1724,  1728,  1732,  1737,  1741,  1744,  1747,  1749,  1752,  1757,
+  1762,  1765,  1767,  1769,  1771,  1774,  1777,  1780,  1782,  1785,
+  1787,  1790,  1793,  1797,  1799,  1803,  1806,  1810,  1813,  1816,
+  1820,  1822,  1826,  1831,  1835,  1838,  1841,  1843,  1847,  1850,
+  1853,  1855,  1858,  1862,  1864,  1868,  1870,  1876,  1880,  1885,
+  1889,  1894,  1897,  1900,  1904,  1907,  1909,  1911,  1914,  1917,
+  1920,  1921,  1922,  1924,  1926,  1929,  1933,  1935,  1938,  1942,
+  1948,  1955,  1961,  1962,  1963,  1970,  1972,  1975,  1977,  1979,
+  1981,  1984,  1985,  1990,  1992,  1993,  1994,  2001,  2002,  2003,
+  2011,  2012,  2013,  2014,  2025,  2026,  2027,  2028,  2039,  2040,
+  2048,  2049,  2055,  2056,  2064,  2065,  2070,  2073,  2076,  2079,
+  2083,  2090,  2099,  2110,  2123,  2128,  2132,  2135,  2138,  2140,
+  2142,  2143,  2144,  2152,  2154,  2157,  2160,  2161,  2162,  2168,
+  2170,  2172,  2176,  2180,  2183,  2186,  2189,  2193,  2198,  2203,
+  2207,  2212,  2219,  2226,  2227,  2229,  2230,  2232,  2234,  2235,
+  2237,  2239,  2243,  2248,  2250,  2254,  2255,  2257,  2259,  2261,
+  2264,  2267,  2270,  2272,  2274,  2277,  2280,  2283,  2286,  2288,
+  2292,  2295,  2298,  2303,  2306,  2309,  2312,  2315,  2318,  2321,
+  2323,  2326,  2328,  2332,  2334,  2336,  2337,  2338,  2340,  2341,
+  2346,  2348,  2350,  2354,  2355,  2359,  2363,  2367,  2369,  2372,
+  2375,  2378,  2381,  2384,  2387,  2390,  2393,  2396,  2399,  2402,
+  2405,  2408,  2411,  2414,  2417,  2420,  2423,  2426,  2429,  2432,
+  2435,  2438,  2442,  2445,  2448,  2451,  2454,  2458,  2461,  2464,
+  2469,  2474,  2478
 };
 
 static const short yyrhs[] = {    -1,
